; *************************************************************************
;
;                      
;                                         v1.0beta                 
;                                              
;                                                           
;                                         
;   Written by Andy Selle - Derived from the original PDP1 version
;         Copyright (C) 1996 Andy Selle, All Rights Reserved
; *************************************************************************


; *************************************************************************
; Data location definitions
; *************************************************************************
SP_Mem  = $80DF ; ($80E0)   (FOR LINK STUFF)
angle1 = $80E1          ; Ship 1 Angle
ship1x = $80E3          ; Ship 1 X Loc
ship1y = $80E5          ; "    " Y "
vect1x = $80E7          ; ship 1 X Vector
vect1y = $80E9          ; "    " Y Vector
angle2 = $80EB          ; Ship 2 Angle
ship2x = $80ED          ; ship 2 x
ship2y = $80EF          ; "    " y
vect2x = $80F1          ; ship 2 X vect
vect2y = $80F3          ; "    " Y "
Torp1x = $80F5
Torp1y = $80F7
Torp1vx = $80F9
Torp1vy = $80FB
point1x = $8115         ; Rotate Point 1 x
point1y = $8116         ; Rotate Point 1 y
point2x = $8117         ; Rotate Point 2 x
point2y = $8118         ; Rotate point 2 y
point3x = $8119         ; Rotate point 3 x
point3y = $811A         ; Rotate point 3 y
Way = $811B             ; Used by Trig
TMp = $811D            ; TMp Storate
TempWord1 = $811F       ; |
TempWord2 = $8121
TempWord3 = $8123
Param = $8127
stat = $8129            ; Stats from Client
Torp2x = $813B          ; Torp 2 x
Torp2y = $813D          ; Torpedo 2 y
Torp2vx = $813F         ; torp vector x
Torp2vy = $8141         ; torp vector y
torp = $8143
TempLine = $8A6B        ; NASR Stuff
PicCoor = $8A78         ; |
offset = $8A7A          ; |
sstat = $8A7F           ; Stats from Server
#include "ti-85.h"

; Some Extra defines for Link port stuff
#DEFINE  JR_(value)      .db $18,value
#DEFINE  JR_Z(value)     .db $28,value
#DEFINE  JR_NZ(value)    .db $20,value
#DEFINE  JR_C(value)     .db $38,value
#DEFINE  JR_NC(value)    .db $30,value


; ********************
;   TITLE Of Program 
; ********************
.org 0
.db "SpaceWar 1.0b",0

; ********************************
; Program Beginning (Start)
; ********************************
Start:
        ld a,4
        out (5),a               ; set to grpah mode

        CALL_(IntroScreen)      ; Display the opening Graphic

InitData:                       ; * Initialize temporary data for game
        ld a,0                  ; a=0
        ld (sstat),a            ; Clear sstat
        ld hl,0                 ; hl=0
        ld (angle1),hl          ; Clear the angle 1
        ld hl,0                 ; hl=0
        ld (angle2),hl          ; Clear angle 2
        ld h,30                 ; hl = 30.00 (h=30)
        ld l,0                  ; (l=0)  hl=$1E00
        ld (ship1x),hl          ; Put 30.0 into ship1x
        ld (ship1y),hl          ; and ship1y  (30,30)
        ld h,40                 ; hl=40.00
        ld l,0                  ; hl=$2800
        ld (ship2x),hl          ; Put 40.0 into ship2x
        ld (ship2y),hl          ; and ship2y (40,40)
        ld ix,angle1            ; load ix with a pointer to angle 1
        ld a,$FF                ; Load 255 signifiying torp out of use
        ld (Torp1x),a           ; Load it into Torp1x and Torp2x
        ld (Torp2x),a           ; |
        ld    hl,0              ; <
        add   hl,sp             ; <  Stack Pointer stuff for Link Routines
        ld    (SP_Mem),hl       ; <

LinkNegotiate:                  ; * Routines to Assign tasks to each calc
        in a,($07)              ; Read the link port
        and $03                 ; Mask off bits 0 and 1
        cp $01                  ; Check if it is a W
        jr nz,SendOutPulse      ; If it isn't then this calc is the server
                                ; jump to server negotiation routine
        ld a,$D4                ; Send an R in confirmation
        out ($07),a             ; Write the reg a to the port
        ld a,$00                
        ld (Param),a            ; Put 0 into Param to signify that this is
                                ; the client
LinkNegoWaitR:                  ; * Wait for the W to be reset by the
                                ; server
        in a,($07)              ; read the port
        and 3                   ; MASK off bits 0 and 1
        cp $02                  ; IS R and only R pulled?
        jr z,NegoClearLink      ; Clear the link (send a $C0 to port7)
        jr LinkNegoWaitR        ; If W is still on go back to the beginning
                                ; and run (loop)
SendOutPulse:                   ; * Send out a pulse as the server
        ROM_CALL(CLEARLCD)      ; Clear the Screen
        ld   hl,(PROGRAM_ADDR)  ; load hl with the address of the program
        ld   de,WaitingStr      ; load de with the address of the string
        add hl,de               ; Calculate the address (add the two together)
        ROM_CALL(D_ZT_STR)      ; Display the text
        ld   a,$E8              ; PULL W to Ground
        out  ($07), a           ; send it
WaitPulse:                      ; * Wait for response *
        in a,($07)              ; Read port
        and $03                 ; mask off bits 0 and 1
        cp $00                  ; wait until both R and W are pulled
        jr z,WaitPulseDone      ; if they are go to next step
        CALL GET_KEY            ; get a key press
        cp K_EXIT               ; is it the exit key
        jr nz,WaitPulse         ; if not jup to waitpulse
        ld a,$C0                ;  if it is clear the link
        out ($07),a             ; actually do it
        ret                     ; return to Zshell
WaitPulseDone:
        ld a,01                 ; Set the param as server ($01)
        ld (Param),a            ; set it
NegoClearLink:
        ld a,$C0                ; Clear the link
        out ($07),a             ; send the clear

DisplayResults:
MainLoop:
        ld a,0                  ; clear the client stat
        ld (torp),a             ; clear it

        ld a,(Param)            ; load the param into the stuff
        cp $01                  ; if it isn't the server
        jr nz,MainGoOn          ;   go to MainGoOn
        CALL_(Server)           ; else it is so go to the Server routine
        jr MainExit             

MainGoOn:
        CALL_(Client)           ; If it isn't the server it logically
                                ; must be the client jump to the client routine

MainExit:

        ld a,$C0        ; CLEAR THE PORT
        out ($07),a

        ret


; **********************************************
; Client : Main Loop for the Client Calculator
;  - Sends input to server
;  - Draws ships, torps, etc.
;  - Receives location updates on all objects
;    from server
; **********************************************

Client:
        CALL_(Delay)                    ; Delay the calc

        ld hl,(angle1)                  ; Load the angle
        ld a,h                          ; put it in accumulator
        CALL_(Send_By)                  ; Send it to other calc
        ld a,l                          ; load low byte
        CALL_(Send_By)                  ; Send other part of it
        ld a,(stat)                     ; load status into a
        CALL_(Send_By)                  ; send it
        bit 2,a                         ; if bit 2 is set on a
        JUMP_NZ(ExitProperly)           ; jump to the exit routine
        ld a,0                          ; load (Stat) with 0
        ld (stat),a                     ; do it0

        ld ix,angle1                    ; Load a pointer to the ship
                                        ; in ix
        ld a,0                          ; INPUT ROUTINES
        out (1),a                       ; clear the link input
        in a,(1)                        ; read input
        cp 0                            ; If it is 0 (no keeys pressed
        JUMP_Z(Serv1G1)                 ; skip over all checks
        bit 6,a                         ; if it is the EXIT KEY
        push af                         ; save af
        jr nz,NoExit                    ; if it isn't go to NoExit
        ld a,$00                        ; load a with 0
        set 2,a                         ; set the 2 bit (a = 00000100)
        ld (stat),a                     ; save that in stat
NoExit:
        pop af                          ; restore af
        bit 1,a                         ; if it is LEFT
        push af                         ; save flag
        CALL_Z(IncrAngle)               ;    if it is left call IncrAngle
        pop af                          ; restore arg
        bit 2,a                         ; if it is RIGHT
        push af                         ; save flag
        CALL_Z(DecrAngle)               ;    if it is right call DecrAngle
        pop af                          ; restore af                           
        bit 3,a                         ; if it is Thrust (UP)
        push af                         ; save arg
        jr nz,Serv1G1a                  ; if it isn't skip over to Serv1G1a
        ld a,(stat)                     ; load the stat
        set 0,a                         ; set right most bit (00000001)
        ld (stat),a                     ; save the new value
Serv1G1a:
        pop af                          ; restore arg
        bit 0,a                         ; is it is down
        jr nz,Serv1G1                   ; if not go to Serv1G1
        ld a,(stat)                     ; otherwise load stat
        set 1,a                         ; set bit 1 (00000010)
        ld (stat),a                     ; save new value in (stat)
Serv1G1:
        ROM_CALL(CLEARLCD)              ; Clear Screen
        ld ix,angle1                    ; load ix with a pointer to the ship
        CALL_(UpdateShip)
        CALL_(Rotate)                   ; call routine to Calculate point
                                        ; positions of ship
        CALL_(DrawShip)                 ; call routine to Draw the ship
        ld ix,angle2                    ; load ix with pointer to second ship
        CALL_(UpdateShip)               
        CALL_(Rotate)                   ; call routine to Calc points of
                                        ; the ship
        CALL_(DrawShip)                 ; call routine to draw using those
                                        ; points
        ld ix,torp1x                    ; Load ix with pointer to first torp
        CALL_(DrawTorp)                 ; call routine to draw torp
        ld ix,torp2x                    ; load ix with pointer to second torp
        CALL_(DrawTorp)                 ; call routine to draw torp
        CALL_(Rece_By)                  ; Receive a byte from calc
        ld h,a                          ; put it in h
        CALL_(Rece_By)                  ; receive byte
        ld l,a                          ; put in l
        ld (angle2),hl                  ; store into angle2
        ld l,00h                        ; load l with 0
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; put in h
        ld (ship2x),hl                  ; save in ship2x
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (ship2y),hl                  ; save in ship2y
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (ship1x),hl                  ; save in ship1x
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (ship1y),hl                  ; save in ship1y
        CALL_(Rece_By)                  ; receive byte
        ld (torp),a                     ; save in torp
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (torp1x),hl                  ; save in torp1x
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (torp1y),hl                  ; save in torp1y
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (torp2x),hl                  ; save in torp2x
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; load into h
        ld (torp2y),hl                  ; save in torp2y
        CALL_(Rece_By)
        ld (sstat),a
        push ix
        push iy
        ld a,(sstat)
        bit 0,a
        jr z,NextExplosCheck
        ld ix,torp2x
        ld iy,angle1
        push af
        CALL_(DoCollis)
        pop af
NextExplosCheck:
        bit 1,a
        jr z,ExplosCheckDone
        ld ix,torp1x
        ld iy,angle2
        CALL_(DoCollis)
ExplosCheckDone:
        pop iy
        pop ix

        JUMP_(Client)                   ; jump back to beginning of routine
        



; ************************************************
; Server :  Main loop for the server calc
;       - Receives input from client calc
;       - Updates locations of ships and torpedos
;       - Draws updates on screen
;       - Sends updates to client
; ************************************************
Server:
        CALL_(Delay)
        CALL_(Rece_By)                  ; receive byte
        ld h,a                          ; store byte in h
        CALL_(Rece_By)                  ; receive byte
        ld l,a                          ; store byte in l
        ld (angle2),hl                  ; store hl in (angle2)
        CALL_(Rece_By)                  ; receive byte
        ld (stat),a                     ; store byte in stat
        bit 2,a                         ; is bit 2 in stat true
        CALL_NZ(ExitProperly)           ; if it is Exit
        bit 0,a                         ; if bit 0 is true
        jr z,CheckIfTorpFired           ; no? then jump to Checkiftorpfired
        push af                         ; save stat in stack
        ld ix,angle2                    ; load pointer to ship 2 into ix
        CALL_(Thrust)                   ; call thrust routine
        pop af                          ; restore stat
CheckIfTorpFired:
        bit 1,a                         ; is first byte true
        jr z,ServerGoOn                 ; no? then jump to ServerGoOn
        push ix                         ; save ix
        push iy                         ; save iy
        ld ix,torp2x                    ; load ix with pointer to torp 2
        ld iy,angle2                    ; load iy with pointer to ship 2
        CALL_(FireTorp)                 ; call fire torpedo routine
        pop iy                          ; restore iy
        pop ix                          ; restore ix
ServerGoOn:
        ROM_CALL(CLEARLCD)              ; Clear screen
        ld hl,$0000
        ld ($800C),hl
        ld hl,(angle1)
        ROM_CALL(D_HL_DECI)
        ld hl,(angle2)
        ROM_CALL(D_HL_DECI)
        ld ix,angle1                    ; load ix with pointer to ship1
        CALL_(UpdateShip)               ; call update ship routine
        CALL_(Wrap1)                    ; call wrap routine
        CALL_(Rotate)                   ; call ship point calc routine
        CALL_(DrawShip)                 ; call draw ship routine
        ld ix,angle2                    ; load ix with pointer to ship 2
        CALL_(UpdateShip)               ; call update ship routine
        CALL_(Wrap1)                    ; call wrap routine
        CALL_(Rotate)                   ; call ship point calc routine
        CALL_(DrawShip)                 ; call draw ship routine

        push ix                         ; save ix
        push iy                         ; save iy
        ld ix,torp1x                    ; load ix with pointer to first torp
        ld iy,angle2                    ; load iy with pointer to ship 2
        CALL_(UpdateTorp)               ; call update torpedo routine
        ld ix,torp1x                    ; load ix with pointer to first torp
        CALL_(DrawTorp)                 ; call draw torpedo routine
        pop iy                          ; restore iy
        pop ix                          ; restrore ix
        push ix                         ; save ix
        push iy                         ; save iy
        ld ix,torp2x                    ; load ix with pointer to torp2
        ld iy,angle1                    ; load iy with pointer to ship 1
        CALL_(UpdateTorp)               ; call update torpedo routine
        ld ix,torp2x                    ; load ix with pointer to torp 2
        CALL_(DrawTorp)                 ; call draw torpedo routine
        pop iy                          ; restore iy
        pop ix                          ; restrore ix

        ld a,0                          ; clear input buf
        out (1),a                       ; do it
        in a,(1)                        ; read port
        ld ix,angle1                    ; load pointer to ship 1 in ix

        bit 6,a                         ; is it EXIT KEY
        JUMP_Z(ExitProperly)            ; yes? then exit
        bit 1,a                         ; is it LEFT
        push af                         ; save af
        CALL_Z(IncrAngle)               ; yes?then increment angle by 15
        pop af                          ; restore af
        bit 2,a                         ; is it RIGHT
        push af                         ; save af
        CALL_Z(DecrAngle)               ; yes?then deincrement angle by 15
        pop af                          ; restore af 
        bit 3,a                         ; is it Thrust (UP)
        push af                         ; save af
        CALL_Z(Thrust)                  ; yes? then call thrust
        pop af                          ; restore af
        bit 0,a                         ; is it down
        jr nz,SG1G                      ; no? then skip to SG1G
        push ix                         ; save ix
        push iy                         ; save iy
        ld ix,torp1x                    ; load ix with torp 1
        ld iy,angle1                    ; load iy with ship 1
        CALL_(FireTorp)                 ; call the fire torp routine
        pop iy                          ; restore iy
        pop ix                          ; restore ix

SG1G:
        ld hl,(angle1);                 ; Load angle of ship 1
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld a,l                          ; get low byte
        CALL_(Send_By)                  ; send it
        ld hl,(ship1x)                  ; load ship location (x)
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(ship1y)                  ; load ship1 y location
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(ship2x)                  ; load ship2 x location
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(ship2y)                  ; load ship2 y location
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ; NEW MAY BE BUGGY BEGIN
        ld a,(torp)                     ; load torp status (useless now need)
                                        ; ******  need to write some code to utilize this
        CALL_(Send_By)                  ; send it
        ld hl,(torp1x)                  ; get torp 1 x
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(torp1y)                  ; load torp 1 y
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(torp2x)                  ; get torp 2 x
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld hl,(torp2y)                  ; load torp 2 y
        ld a,h                          ; get high byte
        CALL_(Send_By)                  ; send it
        ld a,(sstat)                   ; load sstat
        CALL_(Send_By)                 ; send it
        push ix
        push iy
        ld a,(sstat)
        bit 1,a
        jr z,NextExplosCheckS
        ld ix,torp2x
        ld iy,angle1
        push af
        CALL_(DoCollis)
        pop af
NextExplosCheckS:
        bit 0,a
        jr z,ExplosCheckDoneS
        ld ix,torp1x
        ld iy,angle2
        CALL_(DoCollis)

ExplosCheckDoneS:

        pop iy
        pop ix

        ld a,0                          ; load a with 0
        ld (sstat),a                    ; store a as sstat

        JUMP_(Server)                   ; LOOP back to beginning
        ret                             ; pointless not going to cahnge now

; *************************************************************************
;  ExitProperly : Routine that is called when exit is pressed
;       - Clears Link port
;       - then exits to Zshell
; *************************************************************************

ExitProperly:
        ld a,$C0        ; $C0 is the clear stat
        out ($07),a     ; Actually do it
        ret             ; return

; *************************************************************************
; DrawTorp: Draws our Projectile
;       - Gets the address of the projectile structure from ix
;       - Draws it using Magnus Hagander's plot pixel routine
; *************************************************************************

DrawTorp:
        ld a,(ix+0)             ; Load the first byte of the torp struct
        cp $FF                  ; if it is $FF (inactive)
        ret z                   ; return (the torp does not need drawing
        ld a,(ix+1)             ; Get torp 1x int part
        ld b,a           
        ld a,(ix+3)             ; Get torp 1y int part
        ld c,a

        CALL_(PlotPixel)        ; plot it coordinates (b,c)
        inc b                   ; increment the x
        CALL_(PlotPixel)        ; plot it coordinates (b,c)
        inc c                   ; increment the y
        CALL_(PlotPixel)        ; plot "  "           "
        dec b                   ; deincrement the x        
        CALL_(PlotPixel)        ; plot it
        ret                     ; return from routine


; **********************************
; Shoot a nice juicy projectile
; :)   args : ix - torp   iy - ship
; **********************************


FireTorp:
        ld a,(ix+0)             ; load first byte of the torp
        cp $FF                  ; if it isn't $FF (active)
        ret nz                  ; return (you can't fire a torp thats already
                                ; fired :)

        ld c,(iy+0)             ; load the frac part of angle
        ld b,(iy+1)             ; "    "   int  "    "   "
        push bc                 ; save the angle
        ld a,3                  ; multiply trig results by 3
        push ix                 ; save the pointer to the torp
        push iy                 ; "    "   "       "   "  ship
        CALL_(cosx)             ; calculate  a * cos (bc)
        pop iy                  ; recover ship pointer
        pop ix                  ; "       torp "
        ld (ix+4),c             ; save results in x vector
        ld (ix+5),b             ; "    "       "  " "

        pop bc                  ; recover angle
        ld a,3                  ; multiply trig by 3 (speed of torp)
        push ix                 ; save torp pointer
        push iy                 ; save ship pointer
        CALL_(sinx)             ; bc = a * sin (bc)
        pop iy                  ; recover ship pointer
        pop ix                  ; "       torp "
        ld (ix+6),c             ; save frac results in y vect
        ld (ix+7),b             ; save int  "       "  "  "

        ld l,(iy+2)             ; load the ship's frac x
        ld h,(iy+3)             ; "    "   "      integer x
        ld e,(ix+4)             ; load frac x vect
        ld d,(ix+5)             ; load integer x vect
        add hl,de               ; find starting loc of vector
        add hl,de               ; by  (ship x) + 2(vect x)
        ld (ix+0),l             ; load torp location into its spot
        ld (ix+1),h             ; |

        ld l,(iy+4)             ; load the ship's frac y
        ld h,(iy+5)             ; load the ship's integer y
        ld e,(ix+6)             ; load the frac y vect       
        ld d,(ix+7)             ; load the integer y vect
        add hl,de               ; calc the starting loc of torp
        add hl,de               ; (ship y) + 2(vect y)
        ld (ix+2),l             ; load the tor location into the fract y loc
        ld (ix+3),h             ; "    "   "   "        "    "   integer y loc


; THIS IS DEBUGGING CRUD 
; DispTorpInfo:
;        ROM_CALL(CLEARLCD)
;        ld a,'X'
;        ROM_CALL(TX_CHARPUT)
;        ld h,0
;        ld a,(ix+1)
;        ld l,a
;        ROM_CALL(D_HL_DECI)
;        ld a,'Y'
;        ROM_CALL(TX_CHARPUT)
;        ld h,0
;        ld a,(ix+3)
;        ld l,h
;        ROM_CALL(D_HL_DECI)
;
;DrawTorpLoop:
;        HALT
;        CALL GET_KEY
;
;        cp K_F1
;        jr nz,DrawTorpLoop

        ret             ; return

; **************************************************************** 
; Update Torp.... Updates the location... args are                 
; the pointer to the ship structure in iy and the pointer to       
; the torp struct in ix                                            
; **************************************************************** 
UpdateTorp:                     ; * Update the vectors and check if torp
                                ; * went off edge
        ld a,(ix+0)             ; Load the low byte of the torp x
        cp $FF                  ; is it 255 ($FF)
        ret z                   ; if so return because torp inactive
        
        ld h,(ix+1)             ; Load the int part of the torps x
        ld l,(ix+0)             ; Now load the fractional part
        ld a,123                ; Load 123 into a (right extreme of screen)
        cp h                    ; compare 123 with the torp's x
        JUMP_C(DestTorp)        ; if there is a carry h is bigger than a
                                ; then clear the torp because it hit the edge

        ld a,0                  ; load a with 0 (the left extreme of screen)
        cp h                    ; compare it witht he x
        JUMP_NC(DestTorp)       ; if there is no carry (h < a) then
                                ; destruct torp because it went off edge

        ld e,(ix+4)             ; load the x vector low byte
        ld d,(ix+5)             ; load the x vector high byte
        add hl,de               ; add it to the current location
        ld (ix+0),l             ; load the low byte back into mem
        ld (ix+1),h             ;   "   "   high "    "     "   "

        ld h,(ix+3)             ; load high byte of y vect
        ld l,(ix+2)             ; load low byte  "  "  "
        ld a,60                 ; load a with 60 (the upper extreme of scrn)
        cp h                    ; compare it with the integer part of the vect
        JUMP_C(DestTorp)        ; if the vect is greater than 60 destroy torp
                                ; (if off the edge)
        ld a,0                  ; load a with 0 (the lower extreme of scrn)
        cp h                    ; compare a with h
        JUMP_NC(DestTorp)       ; if torp is off edge clear it
                                ; (if a>h)

        ld e,(ix+6)
        ld d,(ix+7)
        add hl,de
        ld (ix+2),l
        ld (ix+3),h

CollisionDetection:
        ld a,(iy+3)
        ld b,(ix+1)
        sub b
        bit 7,a
        jr nz,Collis1Neg
        ld b,3
        cp b
        jr c,CollisionNext
        ret
Collis1Neg:
        ld b,$FD
        cp b
        jr nc,CollisionNext
        ret
CollisionNext:
        ld a,(iy+5)
        ld b,(ix+3)
        sub b
        bit 7,a
        jr nz,Collis2Neg
        ld b,3
        cp b
        jr c,Collision
        ret
Collis2Neg:
        ld b,$FD
        cp b
        jr nc,Collision
        ret
Collision:
        ld a,(angle1)
        ld b,(iy+0)
        cp b
        jr nz,CollisShip1x
        ld a,(sstat)
        set 1,a
        ld (sstat),a
        jr DestTorp
CollisShip1x:
        ld a,(sstat)
        set 0,a
        ld (sstat),a
        

DestTorp:
        ld a,$FF
        ld (ix+0),a
        ld a,0
        ld (ix+1),a
        ld (ix+3),a
        ret

DoCollis:
        push ix
        push iy
        push af
        push bc
        push hl

        ld a,(iy+3)
        ld h,5
        sub h
        ld b,a
        ld a,(iy+5)
        ld h,5
        add a,h
        ld c,a
        ld hl,Explos1
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)
        ld hl,Explos2
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)
        ld hl,Explos3
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)

        ld hl,Explos4
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)

        ld hl,Explos5
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)

        ld hl,Explos6
        ld de,(PROGRAM_ADDR)
        add hl,de
        CALL_(NASR2_1)
        CALL_(Long_Delay)

        pop hl
        pop bc
        pop af
        pop iy
        pop ix
        ret


; *******************
;  Thrust, Add to the Vector of the ship pointed to by IX
; *******************

Thrust:
        ld a,(ix+0)                  ; Load the angle
        ld c,a                       ; Low byte first   
        ld a,(ix+1)                  ; high byte second
        ld b,a


        ld a,1
        push ix
        CALL_(cosx)                     ; Calculate the X
        pop ix
        ld h,b                          ; |Move the results into the thing
        ld l,c                          ; |OPTIMIZE THIS
        srl (hl)                        ; |
        srl (hl)
        srl (hl)
        ld b,h                          ; | Try loading the vect into bc
        ld c,l                          ; | And elim moving it back save two instructs
        ld a,(ix+6)
        ld l,a
        ld a,(ix+7)
        ld h,a
; OLD OLD OLD        ld hl,(vectx)                   ; Load up the vector
        add hl,bc                       ; Add the vector with the trig calcs
        ld (TempWord2),hl               ; Load it into temp area 
        ld a,(ix+0)                  ; Load the angle
        ld c,a                       ; Low byte first   
        ld a,(ix+1)                  ; high byte second
        ld b,a
        ld a,1                          ; dist is 1
        PUSH IX
        CALL_(sinx)                     ; Calculate the Y
        POP IX
        ld h,b                          ; < >Move the args and shift left
        ld l,c                          ;  |this makes the increase in speed slower
        srl (hl)                        ;  |we can optimize this too :)
        srl (hl)                        ;  |we can optimize this too :)
        srl (hl)                        ;  |we can optimize this too :)
        ld b,h                          ;  |
        ld c,l                          ;  |
        ld a,(ix+8)                     ; Load Vect
        ld l,a                          ; Load Vect
        ld a,(ix+9)                     ; Load Vect
        ld h,a                          ; Load Vect
        add hl,bc                       ; Add the stuff
        ld (TempWord3),hl
ThrustCheck1:
        ld de,(TempWord2)
        ld a,d
        bit 7,a
        jr nz,ThrustCheck2
        ld hl,$0600
        CALL CP_HL_DE
        ret c
        jr ThrustCheck3
ThrustCheck2:
        ld de,(TempWord2)
        ld hl,$FA00
        CALL CP_HL_DE
        ret nc
ThrustCheck3:
        ld de,(TempWord3)
        ld a,d
        bit 7,a
        jr nz,ThrustCheck4
        ld hl,$0600
        CALL CP_HL_DE
        ret c
        jr ThrustCheck5
ThrustCheck4:
        ld de,(TempWord3)
        ld hl,$FA00
        CALL CP_HL_DE
        ret nc
ThrustCheck5:
        ld hl,(TempWord2)
        ld a,l
        ld (ix+6),a                   ; Load the sum back into the vector
        ld a,h
        ld (ix+7),a
        ld hl,(TempWord3)
        ld a,l
        ld (ix+8),a
        ld a,h
        ld (ix+9),a


        ret





Rotate:


        ; Start with our first point
        ld a,(ix+0)                  ; Load the angle
        ld c,a
        ld a,(ix+1)
        ld b,a
        ld (TempWord3),bc
; JUST DEBUGGING DISP INFO
;        ld h,b
;       ld l,c
;        ROM_CALL(D_HL_DECI)
        ld a,4                          ; Load the multiplier for cos
        push ix
        CALL_(cosx)                     ; Call a cos bc
        pop ix
        ld a,(ix+3)                   ; load the ship's x
        add a,b                         ; add the location and the offset to
                                        ; get point location
        ld (point1x),a                  ; Load the results into the first pt
        ld bc,(TempWord3)                  ; Load the angle
        ld a,4                          ; load multiplier for sin
        push ix
        CALL_(sinx)                     ; call it 4 sin (bc)
        pop ix
        ld a,(ix+5)                   ; load ship y
        add a,b                         ; add int part of both
        ld (point1y),a                  ; load it into point 1 y
RotateSecondPoint:        ; Start our second point.
        ld hl,(TempWord3)                  ; Load angle
;        ROM_CALL(D_HL_DECI)
        ld de,150                       
        add hl,de                       ; Add 150 to the angle
        ex DE,HL                        ; exchange registers
        ld hl,360                       
        call CP_HL_DE                   ; is de > hl
        jr nc,RotGoOn                   ; if not go onto do the work
        ex DE,HL                        ; Otherwise exchange...
        or a                            ; Clear the carry
        sbc HL,DE                       ; hl = hl - de
        ex de,hl                        ;  hl <-> de
RotGoOn:
        ld b,d                          ; Just get the stuff in the right
        ld c,e                          ; Place...
        ld a,4
        push af                         ; Save the args
        push bc                         ; for later use
        push ix
        CALL_(cosx)                     ; Calc X offset
        pop ix
        ld a,(ix+3)                     ; Get Ship X
        add a,b                         ; add x offset and x loc
        ld (point2x),a                  ; put in point2x
        pop bc                          ; get the args back
        pop af
        push ix
        CALL_(sinx)                     ; Calc Y offset
        pop ix
        ld a,(ix+5)                     ; get ship y
        add a,b                         ; add int part of ship y and offset y
        ld (point2y),a                  ; store in point2y
; AHHH OUR THIRD POINT
        ld hl,(TempWord3)
        ld de,150
        or a
        sbc hl,de
        jr nc,PassupRot1
        ld a,l
        neg
        ld l,a
        ld h,00h
        ld de,360
        ex de,hl
        or a
        sbc hl,de

PassupRot1:
        ld b,h
        ld c,l
        ld a,4
        push af
        push bc
        push ix
        CALL_(cosx)
        pop ix
        ld a,(ix+3)
        add a,b
        ld (point3x),a
        pop bc
        pop af
        push ix
        CALL_(sinx)
        pop ix
        ld hl,(TempWord3)+4
        ld a,(ix+5)
        add a,b
        ld (point3y),a
        
        ret


; ****************************
; Draw the Ship at Index IX
; ****************************


DrawShip:
        ld a,0
        ld (TempWord1),a
        ld hl,(point1x)        ; Load first point of line
        ld de,(point2x)        ; Load Second Point of line
        CALL_(Line)            ; Draw the line
        ld hl,(point2x)        ; Load first point
        ld de,(point3x)        ; Load Second
        CALL_(Line)            ; Draw it
        ld hl,(point3x)        ; load first pt
        ld de,(point1x)        ; load scnd pt
        CALL_(Line)            ; Draw it
        ret

EraseShip:
        ld a,1
        ld (TempWord1),a
        ld hl,(point1x)
        ld de,(point2x)
        CALL_(Line)
        ld hl,(point2x)
        ld de,(point3x)
        CALL_(Line)
        ld hl,(point3x)
        ld de,(point1x)
        CALL_(Line)
        ld a,0
        ld (TempWord1),a

; **********************
;  INCREMENT AND DEINCREMENT ROUTINES FOR TURNING :)
; Index reg (IX)
; ***********************


IncrAngle:
        ld a,(ix+0)                  ; Load the angle
        ld l,a
        ld a,(ix+1)
        ld h,a
        ld de,15     
        add hl,de
        ld de,0168h     ; 360 in hex into de
        call CP_HL_DE   ; Do a compare of hl,de
        jr c,IncrGoOn
        ld hl,0000h
IncrGoOn:
        ld a,l
        ld (ix+0),a
        ld a,h
        ld (ix+1),a
        ret

DecrAngle:
        ld a,(ix+0)                  ; Load the angle
        ld l,a
        ld a,(ix+1)
        ld h,a
        ld de,15
        or a
        sbc hl,de
        ld de,$FFF1     ; -15
        call CP_HL_DE   ; Is hl == -15?
        jr c,DecrGoOn
        ld hl,$0159     ; Then load it with 345
DecrGoOn:
        ld a,l
        ld (ix+0),a
        ld a,h
        ld (ix+1),a
        ret

;**************************
; MOVE THE SHIP!!!!!!!!!!!
;**************************

UpdateShip:
        ld l,(ix+2)                     ; LOAD X*
        ld h,(ix+3)                     ;                       *
        ld e,(ix+6)                     ; LOAD THE VECT
        ld d,(ix+7)
        add hl,de                       ; add em
        ld (ix+2),l
        ld (ix+3),h
        ld l,(ix+4)                     ; Load ship y
        ld h,(ix+5)
        ld e,(ix+8)                   ; Load vect y
        ld d,(ix+9)
        add hl,de                       ; add em
        ld (ix+4),l                     ; Load the Y back into it |
        ld (ix+5),h                     ;                         |
;        CALL_(Wrap1)                    ; Wrap it if it is needed
        ret

; *******************************
;  Wrap the thing around the
;  screen.  This is kinda crappy
; *******************************
Wrap1:
        ld e,(ix+2)             ; Load shipx 
        ld d,(ix+3)
        ld hl,$7B00             ; 123 in hex
        call CP_HL_DE           ; is de > hl
        jr nc,Wrap1Ok           ; if it isn't go onto the next check
        ld hl,$0500  ; 5        ; else wrap it (set x loc to 5)
        ld (ix+2),l             ; Load results back in
        ld (ix+3),h
        jr WarpChkY             ; Now that we wrapped it don't check X again
                                ; Otherwise it will wrap again when it gets to the
                                ; next check :)
Wrap1Ok:
        ld l,(ix+2)             ; Load shipx 
        ld h,(ix+3)
        ld de,$0500             ; Load hex 5 :)
        call CP_HL_DE           ; is shipx < 5 ?
        jr nc,WarpChkY          ; if not go to the y axis wrap checks
        ld hl,$7B00             ; 123 in hex
        ld (ix+2),l             ; Load results back in
        ld (ix+3),h
WarpChkY:
;        ld de,(shipy)           ; load the ship's y
        ld e,(ix+4)
        ld d,(ix+5)
        ld hl,$3C00             ; 60 in hex
        call CP_HL_DE           ; is shipy > 60?
        jr nc,Wrap1Ok1          ; if not go to next check
        ld hl,$0500
;        ld (shipy),hl           ; If so wrap
        ld (ix+4),l
        ld (ix+5),h
        ret                     ; And then we're done and can return
                                ; If this doesn't work we can turn it back :)
                                ; used to be " jr GoHome "
Wrap1Ok1:
;        ld hl,(shipy)           ; Load ship y
        ld l,(ix+4)
        ld h,(ix+5)
        ld de,$0500             ; 5 in hex
        call CP_HL_DE           ; is y < 5
        jr nc,GoHome            ; if not return out of wrap
        ld hl,$3C00             ; if so then set to 60 in hex
;        ld (shipy),hl           ; |
        ld (ix+4),l
        ld (ix+5),h

GoHome:



        ret




; **********************
;  DRAW PIXEL
; **********************
PlotPixel:                      ;draw a pixel (thanks again, magnus)
        ROM_CALL(FIND_PIXEL)
        ld de,$FC00
        add hl,de
        or (HL)
        ld (HL),A
        ret

;****** Short Delay ****
Delay:
        push af
        push bc
        ld   bc,$1700
DelayLoop:
        dec bc
        ld a, b
        or c
        jr nz, DelayLoop
        pop bc
        pop af
        ret


; **** LOng Delay ****
;Long_Delay:
;    push af
;    push bc
;    ld   bc,10000
;Long_Delay_Loop:
;    dec  bc
;    ld   a,b
;    or   c
;    jr   nz,Long_Delay_Loop
;    pop  bc
;    pop  af
;    ret

Long_Delay:
        push af
        push bc
        ld a,$3F
        ld b,$3F
dloop:
        dec a
        jr nz,dloop
        dec b
        jr nz,dloop
        pop bc
        pop af

        ret


; LINK PORT SENDING AND RECEIVING
; Thanks to Pascal Bouron

;
;            Rece_byte
;
; INPUT   : no
; OUTPUT  : a           = Read byte value
Rece_By:
	  push bc
          push de
                ld    e,1       ; for the OR
                ld    c,0       ; byte receive
	        ld    b,8       ; counter
                ld    a,$C0
                out   (7),a
rb_w_Start:
		in    a,(7)
		and 3
                cp  3
                jr    nz,rb_get_bit
		CALL_(Test_ON)
                jr    rb_w_Start	;Attend le un bit
rb_get_bit:
                cp    2
                jr    z,rb_receive_zero
                ld    a,c
                or    e
                ld    c,a
                ld    a,$D4
                out   (7),a
                jr    rb_waitStop

rb_receive_zero:
                ld    a,$E8
                out   (7),a
rb_waitStop:
                CALL_(Test_ON)
		in    a,(7)
		and   3
                jr    z,rb_waitStop
                ld    a,$c0
                out   (7),a
                rl    e
	        djnz	rb_w_Start
                ld    a,c
	  pop de
          pop bc
          ret


;
;            Send_byte
;
; INPUT   : a
; OUTPUT  : no
Send_By:
	  push  bc
	        ld    b,8
                ld    c,a	;byte to send
                ld    a,$C0
                out   (7),a
w_setport3:
		in    a,(7)
		and 3
                cp  3
                jr    z,calc_bit
		CALL_(Test_ON)
                jr    w_setport3	;Attend le Setport(3)
calc_bit:
                ld    a,c
	        and   1
	        jr    z,send_one
send_zero1:
	        ld    a,$E8
	        out   (7),A
                jr    wait_setport
send_one:
	        ld    a,$D4
	        out   (7),A
wait_setport:
		CALL_(Test_ON)
                in    a,(7)
		and   3
                jr    nz,wait_setport 	;Attend le Setport
	        ld    a,$C0
	        out   (7),A
	        srl c
	        djnz w_setport3
          pop bc
          ret

;
;               Test_ON
;
; INPUT   : no
; OUTPUT  : a = Last key pressed
; rem : Go to Choix if [ON] Pressed
Test_ON:
        in      a,(3)
        and     8
        ret     nz
Retour_choix:
        ld a,$C0        ; $C0 is the clear stat
        out ($07),a     ; Actually do it
        ld      sp,(SP_Mem)
        ret

Send_un:
        push af
             ld    a,$D4
             JR_(3)
Send_zero:
        push af                 ; 1
             ld    a,$E8        ; 2
             out   (7),a                                ; Envoie code
             in    a,(7)        ; 2                     ; lit
             and   3            ; 2
             JR_Z(7)            ; 2
             CALL_(Test_ON)     ; 5                     ; Regarde ON
             JR_($F3)          ; 2     , JR -13        ; retourne a lit
             ld    a,$C0
             out   (7),a                                ; Met au repos
             in    a,(7)        ; 2                     ; lit
             and   3            ; 2
             cp    3            ; 2                     ; Repos OK
             JR_Z(7)            ; 2     , JR  Z,+07     ; Si oui saut
             CALL_(Test_ON)     ; 5                     ; Regarde ON
             JR_($F1)           ; 2     , JR -15        ; Retourne a lit
        pop  af
        ret

Rece_bit:
        in   a,(7)         ; 2                          ; lit
        and  3             ; 2
        cp   3             ; 2
        JR_NZ($07)         ; 2     , JR  NZ,+07         ; Si non 00 => Saut
        CALL_(Test_ON)     ; 5                          ; Test ON
        JR_($F1)           ; 2     , JR -15             ; Retourne lit
        cp   1                                          ; Z si 0 , NZ si 1
        JR_NZ($04)         ;       , JR  NZ,+04  = recoit1
        ld    a,$D4        ; 2
        JR_($02)           ; 2     , JR  +02
        ld    a,$E8        ; 2
        out   (7),a
        and   $08          ; => 8 si 1 recu , 0 sinon
        ld    c,a
        in    a,(7)        ; 2
        and   3            ; 2
        JR_NZ($07)         ; 2     , JR   NZ,+7
        CALL_(Test_ON)     ; 5
        JR_($F3)           ; 2     , JR -13
        ld   a,$C0
        out  (7),a
        ld    a,c
        add   a,a                       ; bit 4
        ret

; Trigonometry Routine


AdjustAngleinBC:
	xor     a
	cp      b
	jr      z,Alldone
	ld      h,b
	ld      l,c
	ld      bc,360
	and     a
	sbc     hl,bc
	jr      nc,AAHalfDone
	add     hl,bc
AAHalfDone:
	ld      b,h
	ld      c,l
	jr      Alldone
Alldone:
	ret

sinx:
	push    af              ;save argument
	ld      d,1             ;d=1, use for later
	ld      hl,180
	and     a               ;clear carry
	sbc     hl,bc
	jr      nc,LessE180    ;is angle greater than 180 degrees?

Great180:            
	ld      h,b             ;
	ld      l,c             ;load bc into hl
	ld      bc,180          ;
	and     a               ; bc=bc-180
	sbc     hl,bc           ;
	ld      b,h             ; 
	ld      c,l             ;load hl into bc
	inc     d               ; d=2, remember negated
LessE180:          ;0<=bc<=180 -> 0 is in b and 0<=c<=180
	ld      a,d             ;save d
	ld      de,(PROGRAM_ADDR)
	ld      hl,Trig_Look_Up ;hl=addr of table
	add     hl,de
	ld      d,a             ;restore d
	ld      a,c             ;load angle into accumulator
	cp      90              ;is it 90 degrees?
	jr      nz,not90
	ld      a,128           ;if 90 degrees, sin90=1
	jr      sinloaded
not90:
	sub     90
	jr      nc,Greater90    ;is angle less than or greater than 90
Less90:
	add     hl,bc           ;if less than, go directly to table
	ld      a,(hl)
	jr      sinloaded
Greater90:
	ld      a,180           ;if greater, sin(x)=sin(180-x)
	sub     c               ;subtract from 180
	ld      c,a
	add     hl,bc           ;read from table
	ld      a,(hl)
sinloaded:                      ;x/128 is in a, d will determine sign
	ld      b,a             ;save result
	pop     af              ;get multiplicand back
	bit     7,a             ;test to see if a is negative
	jr      z,apositive
	neg                     ;if negative, negate
	inc     d               ;store negative memory in d
apositive:                      ;now we want a*b/128
	ld      e,a             ;save a
	ld      a,b             ;
	cp      0               ;see if e=0
	jr      z,multiplyby0   ;
	ld      c,0
	xor     a
sinmultiplyloop:
	add     a,e
	jr      nc,nocarry      ;multipy a by b
	inc     c               ;16bit result in ca
nocarry:
	djnz    sinmultiplyloop         
	rl      a               ;shift ca to the left
	rl      c               ;ca/128 now in c
	ld      b,c
	ld      c,a
	dec     d
        jr      z,sinxend
        and     a
        ld      hl,0
        sbc     hl,bc
        ld      b,h
        ld      c,l
	dec     d
        jr      z,sinxend
        and     a
        ld      hl,0
        sbc     hl,bc
        ld      b,h
        ld      c,l
	dec     d
	jr      z,sinxend
multiplyby0:
	ld      bc,0
sinxend:
	ret

cosx:
	ld      hl,90
	add     hl,bc
	ld      b,h
	ld      c,l
	ld      d,a
	CALL_(AdjustAngleinBC)
	ld      a,d
	CALL_(sinx)
	ret           

Trig_Look_Up:
	.db     0,2,4,6,8,11,13,15,17,20
	.db     22,24,26,28,30,33,35,37,39,41
	.db     43,45,47,50,52,54,56,58,60,62
	.db     64,65,67,69,71,73,75,77,78,80
	.db     82,83,85,87,88,90,92,93,95,96
	.db     98,99,100,102,103,104,106,107,108,109
	.db     110,111,113,114,115,116,116,117,118,119
	.db     120,121,121,122,123,123,124,124,125,125
	.db     126,126,126,127,127,127,127,127,127,127

tanx:                                   ;multiplier in de, angle in hl
        push    de
        push    de                      ;save multiplier
        
        ld      b,h                     ;make another copy of angle in bc
        ld      c,l                     ;
        
        ld      de,180                  ;subtract 180 from
        and     a                       ;angle to see if it is
        sbc     hl,de                   ;greater than 180

        jr      c,tanLess180            ;if not, goto tanless180
        
        ld      b,h                     ;if greater than 180, load angle
        ld      c,l                     ;minus 180 into bc
tanLess180:                             ;bc has the semi-reference
        inc     d                       ;load 1 into d
        ld      hl,90                   ;subtract angle from 90
        and     a                       ;to see if it is less than
        sbc     hl,bc                   ;90
        jr      nc,tanLess90            ;if so, jump to tanless90
        ld      hl,180                  ;if greater, load 180 into hl
        and     a                       ;subtract angle from it
        sbc     hl,bc                   ;
        inc     d                       ;load 2 into d
        ld      b,h                     ;save final reference in bc
        ld      c,l                     ;
tanLess90:                              ;already has reference angle
        sla     c                       ;multiply bc by 2
        rl      b                       ;
        ld      a,d                     ;preserves d
        ld      de,(PROGRAM_ADDR)       ;reference the table
        ld      hl,Tan_Table            ;
        add     hl,de                   ;
        add     hl,bc                   ;
        ld      d,(hl)                  ;
        inc     hl                      ;load result into de
        ld      e,(hl)                  ;
        ld      h,a                     ;whatever we had in d before
        dec     h                       ;see if h=1 or 2
        jr      z,tanNotNegative        ;if 1, positive
        set     7,d                     ;if result negative, then tell it so
tanNotNegative:                         ;guess what
        pop     hl                      ;get multiplier
        CALL_(MulDEbyHL)                ;multiply the result by the multiplier
        push    af
        ld      h,c
        ld      l,d
        bit     7,e
        jr      z,TanRoundDown
        inc     hl
TanRoundDown:
        pop     af
        jr      z,ResPositive
        ex      de,hl
        ld      hl,0
        and     a
        sbc     hl,de
        pop     de
        ret
ResPositive:                  
        pop     de
        ret

MulDEbyHL:
        ld      ix,TempLine
        bit     7,d
        jr      z,DEPositive
        res     7,d
        bit     7,h
        jr      z,HLPositive
        res     7,h
        jr      DEPositive
HLPositive:
        set     7,h
DEPositive:
        ld      (ix+0),h
        ld      (ix+1),l
        ld      b,8
        xor     a
        ld      c,a
        ld      hl,0
MulLoop1:        
        rrc     (ix+1)
        jr      nc,NoAdd1
        add     hl,de
        adc     a,c
NoAdd1:
        sla     e
        rl      d
        rl      c
        djnz    MulLoop1
        ld      b,7
        ld      e,d
        ld      d,c
        ld      c,0
        rl      c
        ld      (ix+5),l
        ld      l,h
        ld      h,a
        xor     a
MulLoop2:        
        rrc     (ix+0)
        jr      nc,NoAdd2
        add     hl,de
        adc     a,c
NoAdd2:
        sla     e
        rl      d
        rl      c
        djnz    MulLoop2
        ld      b,a
        ld      c,h
        ld      d,l
        ld      e,(ix+5)
        bit     0,(ix+0)
        ret
        
Tan_Table:
        .db     0,0,0,4,0,9,0,13,0,18,0,22,0,27,0,31,0,36,0,41
        .db     0,45,0,50,0,54,0,59,0,64,0,69,0,73,0,78,0,83,0,88
        .db     0,93,0,98,0,103,0,109,0,114,0,119,0,125,0,130,0,136,0,142
        .db     0,148,0,154,0,160,0,166,0,173,0,179,0,186,0,193,0,200,0,207
        .db     0,215,0,223,0,231,0,239,0,247,1,0,1,9,1,19,1,28,1,38
        .db     1,49,1,60,1,72,1,84,1,96,1,110,1,124,1,138,1,154,1,170
        .db     1,187,1,206,1,225,1,246,2,13,2,37,2,63,2,91,2,122,2,155
        .db     2,191,2,231,3,20,3,69,3,125,3,187,4,3,4,85,4,180,5,37
        .db     5,172,6,80,7,30,8,37,9,132,11,110,14,77,19,21,28,163,57,74

Line:
        push    DE              ;can be removed
        push    HL              ;can be removed

        ld      A,D
        sub     H
        jr      NC,DXpositive    ;delta_x > 0
DXNegative:
        neg
DXPositive:
        ld      B,A              ;B <- |delta_x|
        ld      A,E
        sub     L
        jr      NC,DYpositive    ;delta_y > 0
DYNegative:
        neg
DYPositive:                
        sub     B               ;|delta_y|
        push    AF
        jr      C,DeltaX        ;|delta_x| > |delta_y|
DeltaY:
        ld      A,H             ;if |delta_x| < |delta_y| then
        ld      H,L             ;then values x and y are swapped
        ld      L,A             ;so the loop will always be performed on the
        ld      A,D             ;x value. A flag must be set to 
        ld      D,E             ;remind that data must be drawn (y,x) 
        ld      E,A             ;instead of (x,y)

        ;ld      A,$01           
        ;ld      (Flag),A        ;the Flag !!!
DeltaX:
        ld      A,D
        sub     H
        jr      NC,TestDY        ;x1 < x2 
TestDX:
        ex	DE,HL
TestDY:
        ld      A,E
        sub     L
        ld      A,$01
        jr      NC,StoreA
        neg                     ;y1 > y2 : in case2 the 'y' variable
StoreA:
        ld      (Way),A
InitLine:       
        ld      B,H
        ld      C,L
        ld      A,E
        sub     L
        jr      NC,EndInit
        ld      A,L
        ld      L,E
        ld      E,A
EndInit:
        ld      A,E      
        sub     L
        rla
        ld      L,A             ;value to add in case1 (d < 0)
        add     A,H
        sub     D
        ld      E,A             ;'d' variable is initialised
        add     A,H
        sub     D
        ld      H,A             ;value to add in case2 (d >= 0)
Loop:
        ld      A,B
        sub     D
        jr      NC,EndLine       ;the line is completely drawn.
        pop     AF
        ;ld      A,(Flag)
        bit     7,A
        push    AF
        push    AF
        push    BC
        jr      Z,DrawPoint
        ld      A,B
        ld      B,C
        ld      C,A
DrawPoint:     
        CALL_(PointOn)
        pop     BC
        pop     AF
TestD:
        bit     7,E
        jr      NZ,Case1
Case2:                          ;d >= 0 
        ld      A,E
        add     A,H
        ld      E,A
        ld      A,(Way)
        add     A,C
        ld      C,A
        jr      EndLoop
Case1:                          ;d < 0
        ld      A,E
        add     A,L
        ld      E,A
EndLoop:
        inc     B
        jr      Loop
EndLine:
        pop     AF              ;MUST NOT BE REMOVED
        pop     HL              ;can be removed
        pop     DE              ;can be removed
        ret

PointOn:
        push    DE              ;MUST NOT BE REMOVED
        push    HL              ;MUST NOT BE REMOVED
        ROM_CALL(FIND_PIXEL)
        ld      DE,$FC00
        add     HL,DE
        or      (HL)
        ld      (HL),A
        pop     HL              ;MUST NOT BE REMOVED
        pop     DE              ;MUST NOT BE REMOVED
        ret             


NASR2_1:    
        push    bc
        ex      de,hl
        ROM_CALL(FIND_PIXEL)
        ld      bc,$fc00
        add     hl,bc
        ld      (PicCoor),hl
        ex      de,hl
        ld      b,$ff
Patch:
        rla
        inc     b
        jr      nc,Patch
        ld      a,(hl)
        ld      c,a      
        inc     hl
        ld      a,b   
        ld      e,c
        cp      (hl)
        jr      c,DS1
        inc     e
DS1:
        inc     hl
        ld      a,(hl)
        ld      d,a
        inc     hl
YLoop:            
        push    bc 
        push    de
        ld      b,8
        ex      de,hl
        ld      hl,TempLine
InitTempLineLoop:
        ld      (hl),0
        inc     hl
        djnz    InitTempLineLoop
        ex      de,hl
        ld      b,0
        ld      de,TempLine
        ldir       
        pop     de
        pop     bc
        ld      a,b
        cp      0 
        CALL_NZ(ShiftLine)   
        push    bc
        push    hl
        push    de
        ld      c,e
        ld      hl,(PicCoor)
        ld      de,16
        push    hl
        add     hl,de
        ld      (PicCoor),hl
        pop     hl
        ld      de,TempLine
        ex      de,hl
        ld      b,0
        ldir      
        pop     de
        pop     hl
        pop     bc
        dec     d
        jr      nz,YLoop
        pop     bc
        ret


ShiftLine:
        push    hl
        push    bc 
SpriLoop1:
        ld      a,b    
        ld      HL,TempLine
        ld      b,e
        and     a
SpriLoop2:        
        rr      (HL)
        inc     HL
        djnz    SpriLoop2
        ld      b,a
        djnz    SpriLoop1        
        pop     bc
        pop     hl
        ret                                         

Explos1:
        .db     2,6,11
;                12345678  901
        .db     %00000000,%00000000  ;1
        .db     %00000000,%00000000  ;2
        .db     %00000000,%00000000  ;3
        .db     %00000000,%00000000  ;4
        .db     %00000100,%00000000  ;5
        .db     %00001110,%00000000  ;6
        .db     %00000100,%00000000  ;7
        .db     %00000000,%00000000  ;8
        .db     %00000000,%00000000  ;9
        .db     %00000000,%00000000  ;0
        .db     %00000000,%00000000  ;1

Explos2:
        .db     2,6,11
;                12345678  901
        .db     %00000000,%00000000  ;1
        .db     %00000000,%00000000  ;2
        .db     %00000110,%00000000  ;3
        .db     %00011111,%00000000  ;4
        .db     %00001110,%00000000  ;5
        .db     %00001110,%00000000  ;6
        .db     %00011110,%00000000  ;7
        .db     %00011100,%00000000  ;8
        .db     %00000000,%00000000  ;9
        .db     %00000000,%00000000  ;0
        .db     %00000000,%00000000  ;1
Explos3:
        .db     2,6,11
;                12345678  901
        .db     %00001110,%00000000  ;1
        .db     %00111111,%00000000  ;2
        .db     %01111111,%10000000  ;3
        .db     %01111111,%11000000  ;4
        .db     %01111011,%11000000  ;5
        .db     %01111011,%11000000  ;6
        .db     %00111111,%11100000  ;7
        .db     %00011111,%10000000  ;8
        .db     %00111111,%11000000  ;9
        .db     %00011111,%11000000  ;0
        .db     %00000110,%11000000  ;1
Explos4:
        .db     2,6,11
;                12345678  901
        .db     %00000000,%00000000  ;1
        .db     %00010011,%00000000  ;2
        .db     %00110101,%00000000  ;3
        .db     %00000000,%00000000  ;4
        .db     %00110001,%10000000  ;5
        .db     %01100000,%10000000  ;6
        .db     %01100110,%00000000  ;7
        .db     %01000110,%00000000  ;8
        .db     %00110011,%00000000  ;9
        .db     %00111000,%00000000  ;0
        .db     %00000000,%00000000  ;1

Explos5:
        .db     2,6,11
;                12345678  901
        .db     %00000000,%00000000  ;1
        .db     %00000001,%00000000  ;2
        .db     %01000000,%00000000  ;3
        .db     %01000000,%00000000  ;4
        .db     %00001000,%00000000  ;5
        .db     %00000000,%00000000  ;6
        .db     %00000000,%01000000  ;7
        .db     %00000000,%00000000  ;8
        .db     %00000001,%00000000  ;9
        .db     %00100000,%00000000  ;0
        .db     %00000000,%00000000  ;1
Explos6:
        .db     2,6,11
;                12345678  901
        .db     %00000000,%00000000  ;1
        .db     %00000000,%00000000  ;2
        .db     %00000000,%00000000  ;3
        .db     %00000000,%00000000  ;4
        .db     %00000000,%00000000  ;5
        .db     %00000000,%00000000  ;6
        .db     %00000000,%00000000  ;7
        .db     %00000000,%00000000  ;8
        .db     %00000000,%00000000  ;9
        .db     %00000000,%00000000  ;0
        .db     %00000000,%00000000  ;1

IntroScreen:
        DI
        ld      HL,$FFFF
        xor     A
        ld      (HL),A
        ld      DE,$FFFE
        ld      BC,$03FF
        lddr
        exx
        ld      HL,(PROGRAM_ADDR)
        ld      DE,ZCP
        add     HL,DE
        ld      C,$80
ZCPLoop:
        ld      A,(HL)
        inc     HL
        ld      D,A
        or      A
        jr      Z,EndDecode
        rlca
        jr      C,Copy
Stream:
        ld      A,D
        and     $3F
        ld      B,A
        ld      A,D
        and     $40
StreamLoop:
        or      A
        jr      Z,SLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
SLSuite:
        srl     C
        jr      NC,DjnzSL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzSL:
        djnz    StreamLoop
        jr      ZCPLoop
Copy:
        ld      B,$07
CopyLoop:
        rlca
        jr      NC,CLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
CLSuite:
        srl     C
        jr      NC,DjnzCL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzCL:
        djnz    CopyLoop
        jr      ZCPLoop

EndDecode:
        ld hl,$294F
        ld ($8333),hl
        ld hl,(PROGRAM_ADDR)
        ld de,AuthorStr
        add hl,de
        ROM_CALL(D_ZM_STR)
        ld hl,$2F4F
        ld ($8333),hl
        ld hl,(PROGRAM_ADDR)
        ld de,CopyStr
        add hl,de
        ROM_CALL(D_ZM_STR)
        ld hl,$3901
        ld ($8333),hl
        ld hl,(PROGRAM_ADDR)
        ld de,EnterStr
        add hl,de
        ROM_CALL(D_ZM_STR)

EndDecodeLoop:
        call    GET_KEY
        or      A
        jr      Z,EndDecodeLoop
        exx
        EI
        ret

AuthorStr:      .db "by Andy Selle",0
CopyStr:        .db "(C)1996",0
EnterStr:       .db "Press [Enter] to Continue",0


ZCP:                  ;DO NOT REMOVE THIS LINE

      .db    $3F,$3F,$3F,$3F,$80,$4C,$13,$C0,$0F,$FC,$83,$3D,$4C,$0B,$C0,$17
      .db    $FC,$83,$3D,$F8,$2E,$FC,$83,$3D,$F8,$1B,$C0,$84,$83,$F0,$8C,$3B
      .db    $F8,$82,$08,$C0,$A0,$11,$FC,$83,$3D,$F8,$2E,$FC,$83,$3D,$F8,$2E
      .db    $FC,$83,$25,$C0,$09,$C0,$BF,$FE,$4A,$9F,$EF,$F3,$FF,$9F,$98,$E7
      .db    $FE,$4B,$0D,$F0,$12,$4C,$BF,$F9,$FE,$FF,$9F,$F9,$F9,$C6,$BF,$F7
      .db    $48,$0C,$FC,$1C,$F7,$C3,$9C,$EE,$83,$E1,$9F,$98,$E7,$86,$F8,$0F
      .db    $FE,$1D,$F7,$C3,$9C,$EE,$83,$FF,$9F,$98,$E7,$86,$F8,$0E,$48,$1D
      .db    $F7,$C3,$9C,$EE,$83,$FF,$9F,$98,$E7,$86,$F8,$0C,$4A,$1D,$F7,$C3
      .db    $9C,$EE,$83,$E0,$9F,$98,$E7,$86,$F8,$0B,$4C,$1C,$F7,$C3,$9C,$EE
      .db    $83,$E0,$9F,$98,$E7,$86,$F8,$0A,$4D,$13,$4C,$BF,$F9,$FE,$FF,$9F
      .db    $F9,$4D,$9F,$FB,$E0,$80,$4B,$23,$F8,$0A,$E0,$27,$E0,$0B,$49,$26
      .db    $F8,$3F,$0A,$FE,$29,$F8,$3F,$0A,$F0,$29,$F8,$33,$C0,$3F,$F8,$3F
      .db    $3A,$F8,$3F,$2E,$C0,$83,$E0,$3F,$84,$88,$2A,$F8,$39,$E0,$3F,$A0
      .db    $33,$E0,$3F,$26,$FF,$37,$C0,$86,$31,$4D,$3F,$F0,$2C,$4F,$3C,$D7
      .db    $0D,$C0,$19,$51,$3D,$EB,$2A,$53,$0F,$D0,$25,$EA,$F0,$23,$55,$20
      .db    $C0,$13,$D5,$AC,$22,$57,$39,$EA,$D7,$22,$57,$39,$D5,$AA,$E0,$1A
      .db    $59,$38,$EA,$D5,$B8,$98,$13,$59,$15,$C0,$09,$C0,$0B,$EA,$D5,$FC
      .db    $8C,$14,$59,$37,$D7,$FF,$22,$59,$37,$FC,$29,$59,$3F,$28,$59,$3F
      .db    $28,$59,$3F,$29,$57,$3F,$2A,$57,$2E,$C0,$0A,$C0,$24,$55,$3F,$2D
      .db    $53,$3F,$0F,$C0,$19,$51,$27,$C0,$3F,$8F,$4B,$0C,$C0,$0C,$C0,$3F
      .db    $08,$C3,$4B,$3F,$37,$FF,$3F,$3F,$C0,$3F,$3F,$3F,$3F,$3F,$3F,$3F
      .db    $3F,$30,$C0,$19,$C0,$3F,$80,$C0,$3F,$14,$C0,$39,$C0,$0C,$C0,$3F
      .db    $3F,$0A,$C0,$3F,$3F,$36,$C0,$11,$C0,$00
;--- Data stream size : 361 bytes.

WaitingStr:     .db "Waiting for response "
                .db "other calculator....."
                .db "                     "
                .db "Press [ON] to Exit.  ",0

PauseStr:       .db "Paused",0
ExitStr:        .db "Exit by Opponent",0
.end
